package com.kino.video_360

import android.content.Context
import android.opengl.GLES20
import android.util.AttributeSet
import android.util.Log
import android.view.Surface
import android.view.ViewGroup
import android.widget.FrameLayout
import com.google.android.exoplayer2.Player
import com.google.android.exoplayer2.ui.AspectRatioFrameLayout
import com.google.android.exoplayer2.ui.PlayerView
import com.google.android.exoplayer2.ui.StyledPlayerView
import com.google.android.exoplayer2.video.VideoSize
import com.kino.video_360.custom.GLTextureView
import javax.microedition.khronos.egl.EGLConfig
import javax.microedition.khronos.opengles.GL10

class CustomPlayer : PlayerView {

    private lateinit var surfaceView: GLTextureView
    private var surface: Surface? = null

    private var updateSurface: Boolean = false

    constructor(context: Context) : super(context) {
        init()
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        init()
    }

    constructor(context: Context, attrs: AttributeSet, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
        init()
    }

    private fun init() {

        surfaceView = findViewById(R.id.player_surface_view)

//        val mainView: AspectRatioFrameLayout = findViewById(R.id.exo_content_frame)
//
//        val layout = ViewGroup.LayoutParams(
//            FrameLayout.LayoutParams.MATCH_PARENT, FrameLayout.LayoutParams.MATCH_PARENT
//        )
//
//        surfaceView = GLTextureView(context)
//        surfaceView.layoutParams = layout
//
//        mainView.addView(surfaceView, 0)

//        val playerListener = object : Player.Listener {
//            override fun onVideoSizeChanged(videoSize: VideoSize) {
//                super.onVideoSizeChanged(videoSize)
//
//                surfaceView.onSurfaceTextureSizeChanged(surfaceView.surfaceTexture!!,
//                    videoSize.width, videoSize.width)
//            }
//        }

        surfaceView.setEGLContextClientVersion(2)
        surfaceView.setEGLConfigChooser(8, 8, 8, 8, 16, 8)
        surfaceView.setRenderer(object : GLTextureView.Renderer {
            override fun onSurfaceCreated(gl: GL10?, config: EGLConfig?) {

                player?.setVideoTextureView(surfaceView)

//                player?.addListener(playerListener)

//                surface = Surface(surfaceView.surfaceTexture)
//                player?.setVideoSurface(surface)

//                surfaceView.requestRender()

                Log.e("customPlayer", "created")
//                player?.setVideoSurface(surface)
            }

            override fun onSurfaceChanged(gl: GL10?, width: Int, height: Int) {
                Log.e("customPlayer", width.toString())
                Log.e("customPlayer", height.toString())
            }

            override fun onDrawFrame(gl: GL10?) {
//                Log.e("customPlayer", "!!")

                synchronized (this) {

//                    surfaceView.requestRender()

//                    if (updateSurface) {
//                        surfaceView.surfaceTexture?.updateTexImage()
////                        surfaceView.surfaceTexture?.getTransformMatrix(this.mSTMatrix)
//                        updateSurface = false
//                    }
                }
            }
        })

//        player?.addListener(object : Player.Listener {
//            override fun onRenderedFirstFrame() {
//                super.onRenderedFirstFrame()
//                Log.e("TATAWSTAST", "bbbbbb")
//            }
//
//            override fun onVideoSizeChanged(videoSize: VideoSize) {
//                super.onVideoSizeChanged(videoSize)
//                Log.e("TATAWSTAST", "asdasdsadasd")
//            }
//        })

        surfaceView.renderMode = GLTextureView.RENDERMODE_CONTINUOUSLY
    }

//    @Synchronized
//    fun onFrameAvailable(st: SurfaceTexture?) {
//        updateSurface = true
//        mView.requestRender()
//    }
}